#ifndef TREEH_H
#define TREEH_H

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdbool.h>

#define NBCHAR 26 //A-Z


typedef struct _node node, *tree;
struct _node{
  char letter;
  char isEnd;
  //0 no,1 yes,+2 if ends with 's
  //+4if proper, +8if allUpper 
  node* next[NBCHAR];
};

tree make_empty_tree();//create a null node*
node* make_empty_node();//malloc a node and initialize it
node* make_node(char,bool);//id
void delete_tree(tree);//free(tree) and delete tree on all t->next

bool is_empty(tree);//==NULL
bool is_followed(tree);//if true tree has following letters

bool is_end(tree);//if true word can end here
bool is_proper_end(tree);//if true 1st letter is upper  
bool is_common_end(tree);//if true all letters are lower
bool is_acronyme_end(tree);//if true all letters are upper
bool ends_with_apostrophe(tree);//if true word can be word's

int hash(char);//need to check if isalpha

//recursive can only be called in a dico instance
void addto_tree(tree,string,int);
void addto_tree2(tree,string);


#endif //TREEH_H
